
ArrayList<Threads> threads; //Ablage für die verschiedenen Threads
int nummerThread;
float[][] Matrix;//für Konvergenz
float[][] MatrixTemp;
float[][] MatrixGesamt;
int[][] MatrixPerm;//für Konvergenz
int[][] MatrixPermTemp;
int[][] MatrixPermGesamt;
int[][] matrix1,matrix2,matrix3;
int n;
float a,b,c,d,delta;
float A,B,C,D,Delta;
float abstand = 0.000001;
int anzahlThreads = 12;
PImage bildErgebnis,bild,bildVerschluesselt,bildEntschluesselt;
PImage bildXOREntschluesselt,bildXORSchluessel,bildXORVerschluesselt;
PImage bildPERMEntschluesselt,bildPERMErgebnis,bildPERMSchlussel;
boolean schluesselErzeugen = false;
boolean verschluesseln=false;
boolean entschluesseln=false;
int cols,Cols,rows;
int m = 256; //Anzahl Folgepunkte für sw für schnelle Suche
int bL = 10;//Blinddurchläufe
int konvTestBis = 500;
int part;
int partPerm;
float  G = 20;
float xZ =0;
float yZ =0;
float minX = -G+xZ;
float maxX =  G+xZ;
float minY = -G+yZ;
float maxY =  G+yZ;
float wh = maxX-minX;
float dK,sW;
float[]SA;//Summe Abstand
float[]SW;//Summe Winkel
float dKperm, sWperm;
float[]SAperm;//Summe Abstand
float[]SWperm;//Summe Winkel
color f,c1,c2,cBin1,cBin2,cBin3;;
float anteil =2*G/(float)anzahlThreads;//y-Anteil für jeden Thread
String[] permSchluessel;

void setup(){
  size(1200,1200);//cols durch anzahlThreads teilbar
  cols = width;
  rows = height;
  Cols = 2*cols;
  background(255);
  colorMode(RGB,255,255,255,255);
  n = Cols*rows;
  sW = 2*G/(float)height;
  dK = 2*G/(float)anzahlThreads;
  sWperm = 2*G/(float)Cols;
  dKperm = 2*G/(float)anzahlThreads; 
  permSchluessel = new String[n];
  part = height/anzahlThreads;
  partPerm =Cols/anzahlThreads;  
  fill(0);
  textSize(24);
  text("Ver- und Entschlüsseln mit Clifford Attraktor", 40, 40); 
  text("Verwenden Sie die Tasten:", 40, 100); 
  text("<s> für das erstellen eines XOR- und eines Permutation Schlüssels. (Dauert zwei-drei Minuten)",40, 140);  
  text("<v> für das Verschlüsseln eines Bildes. Das Bild bild.bmp muss sich im data-Ordner befinden.",40,180);
  text("        bild.bmp muss die Größe 1200x1200 haben", 40,260);
  text("        Ebenso auch die Schlüssel schluesselXOR.bmp und permSchluessel.txt", 40,220);
  text("<e> für das Entschlüsseln eines Bildes. Das Bild bildVerschluesselt.bmp muss sich im data-Ordner befinden.", 40, 300);   
  text("        Ebenso auch schluesselXOR.bmp und  permSchluessel.txt", 40, 340); 
     
 //a = random(-2.5,2.5); b = random(-2.5,2.5); c = random(-2.5,2.5); d = random(-2.5,2.5);  delta = random(2.5,5.5);
   a = -0.4400816;  b = -1.8645766;  c = 0.7086589;  d =  2.2232118;  delta = 5.3316155;
   A = -2.2647035;  B =  1.4727635;  C = 2.4895631;  D = -0.9899288;  Delta = 3.4015532; 

   println("a = "+a+";  b = "+b+";  c = "+c+";  d = "+d+";  delta = "+delta+"; ");
   println("A = "+A+";  B = "+B+";  C = "+C+";  D = "+D+";  Delta = "+Delta+"; ");
}
/////////////////////////////////////////////////////////////////
void draw(){ 
  if(schluesselErzeugen){     
    println("Gestartet!");    
    Matrix = new float[cols][rows];
    MatrixTemp = new float[cols][rows];   
    MatrixGesamt =  new float[cols][rows];  
    MatrixPerm = new int[Cols][rows];
    MatrixPermTemp = new int[Cols][rows];   
    MatrixPermGesamt =  new int[Cols][rows];     
    for (int i = 0; i < cols; i ++ ) {
      for (int j = 0; j < rows; j ++ ) {
        Matrix[i][j] = 0;
        MatrixTemp[i][j] = 0;
        MatrixGesamt[i][j]= 0;     
      }
    }   
    for (int i = 0; i < Cols; i ++ ) {
      for (int j = 0; j < rows; j ++ ) {
        MatrixPerm[i][j] = 0;
        MatrixPermTemp[i][j] = 0;
        MatrixPermGesamt[i][j]= 0;     
      }
    }        
    nummerThread =0;
    
    threads = new  ArrayList<Threads>(); //Initialisierung  
    while(nummerThread <anzahlThreads){
        Threads t = new Threads(nummerThread);//Initialisierung
        threads.add(t); //Thread zur ArrayList hinzufügen
        t.start();  //Start des aktuellen Thread
        nummerThread ++;
    }    
    for(Threads t: threads){
        while (t.running){    //warten bis alle Threads fertig sind   
              try{
              Thread.sleep(10);  
              }catch (Exception e) {  }  ;                
         }
         if(t.gibNummer() ==0){
           //println("fertig!");
         }      
    }
    
   //Abrufen der Teilergebnisse  xor 
   for(int K=0; K< anzahlThreads;K++){       
      for (int i = 0; i < cols; i ++ ) {
         for (int j = 0; j < rows; j ++ ) {        
           MatrixTemp[i][j] = threads.get(K).MErgebnis[i][j][K]; 
           Matrix[i][j] = Matrix[i][j]+ MatrixTemp[i][j];
        }
      }     
   }  
   
  for (int i = 0; i < cols; i ++ ) {
         for (int j = 0; j < rows; j ++ ) {                      
             MatrixGesamt[i][j]= Matrix[i][j];         
         }
   } 
   
    //Abrufen der Teilergebnisse  perm    
    for(int K=0; K< anzahlThreads;K++){       
      for (int i = 0; i < Cols; i ++ ) {
         for (int j = 0; j < rows; j ++ ) {        
           MatrixPermTemp[i][j] = threads.get(K).MErgebnisPerm[i][j][K]; 
           MatrixPerm[i][j] = MatrixPerm[i][j]+ MatrixPermTemp[i][j];
        }
      }     
   }  
   
  for (int i = 0; i < Cols; i ++ ) {
         for (int j = 0; j < rows; j ++ ) {                      
             MatrixPermGesamt[i][j]= MatrixPerm[i][j];         
         }
   } 
  
  
   zeichnen();     
   schluesselErzeugen = false;   
   }
   
    if(verschluesseln){
      println("Bild wird verschlüsselt!");   
      bild = loadImage("data/bild.bmp");
      image(bild,0,0);
      //xor
      bildXORSchluessel = loadImage("data/schluesselXOR.bmp");
      matrix1 = matrixVonBildXOR(bild);
      matrix2 = matrixVonBildXOR(bildXORSchluessel);
      matrix3 = new int[cols][rows];
      for(int i=0; i<rows;i++){
         for(int j=0; j<cols;j++){
             c1 = color(matrix1[i][j]);
             c2 = color(matrix2[i][j]);
             int a = 255 << 24;
             int r = int(red(c1)) << 16;
             int g = int(green(c1)) << 8;
             int b = int(blue(c1));
             int A = 255 << 24;
             int R = int(red(c2)) << 16;
             int G = int(green(c2)) << 8;
             int B = int(blue(c2));
             cBin1 = a | r | g | b; 
             cBin2 = A | R | G | B;           
             int aa = 255 << 24; 
             int rr = r ^ R; 
             int gg = g ^ G; 
             int bb = b ^ B;
             cBin3 = aa | rr | gg | bb;
             matrix3[i][j] = cBin3;           
         }       
       }
       bildXORVerschluesselt= bildVonMatrixXOR(matrix3);
       bildXORVerschluesselt.save("data/bildXORVerschluesselt.bmp");
       image(bildXORVerschluesselt,0,0);
       
       //Permutation
       permSchluessel = loadStrings("data/permSchluessel.txt");
       int ax, ay, bx, by;
       color tauschA = color(0,0,0);
       color tauschB = color(0,0,0);
       for(int i=0;i<cols;i++){
         for(int j=0;j<rows;j++){
           int nummer = 2*(i+j*cols);
           ax=Integer.parseInt(permSchluessel[nummer]);
           ay=Integer.parseInt(permSchluessel[nummer+1]);
           bx=i;by=j;
           tauschA = bildXORVerschluesselt.get(ax,ay);
           tauschB = bildXORVerschluesselt.get(bx,by);
           bildXORVerschluesselt.set(ax,ay,tauschB) ;
           bildXORVerschluesselt.set(bx,by,tauschA) ;
         }      
     }
     bildErgebnis = bildXORVerschluesselt;
     bildErgebnis.save("data/bildVerschluesselt.bmp");
     bild = loadImage("data/bildVerschluesselt.bmp");
     image(bild,0,0);  
     println("Verschlüsselung beendet!");   
     verschluesseln = false;
  }
   if(entschluesseln){
      println("Bild wird entschlüsselt!");   
      bildVerschluesselt = loadImage("data/bildVerschluesselt.bmp");
      image(bildVerschluesselt,0,0);
     
      //Permutation
      permSchluessel = loadStrings("data/permSchluessel.txt");
      int ax, ay, bx, by;
      color tauschA = color(0,0,0);
      color tauschB = color(0,0,0);
      for(int i=cols-1;i>=0;i--){
         for(int j=rows-1;j>=0;j--){
           int nummer = 2*(i+j*cols); 
           bx=Integer.parseInt(permSchluessel[nummer]);
           by=Integer.parseInt(permSchluessel[nummer+1]);
           ax=i;ay=j;
           tauschA = bildVerschluesselt.get(bx,by);
           tauschB = bildVerschluesselt.get(ax,ay);
           bildVerschluesselt.set(bx,by,tauschB) ;
           bildVerschluesselt.set(ax,ay,tauschA) ;
         }      
      }
      bildPERMEntschluesselt=bildVerschluesselt;
      bildPERMEntschluesselt.save("data/bildPERMEntschluesselt.bmp");
      bild = loadImage("data/bildPERMEntschluesselt.bmp");
      image(bild,0,0);  
      bildXORSchluessel = loadImage("data/schluesselXOR.bmp");
      matrix1 = matrixVonBildXOR(bildPERMEntschluesselt);
      matrix2 = matrixVonBildXOR(bildXORSchluessel);
      matrix3 = new int[cols][rows];
       for(int i=0; i<rows;i++){
         for(int j=0; j<cols;j++){
             c1 = color(matrix1[i][j]);
             c2 = color(matrix2[i][j]);
             int a = 255 << 24;
             int r = int(red(c1)) << 16;
             int g = int(green(c1)) << 8;
             int b = int(blue(c1));
             int A = 255 << 24;
             int R = int(red(c2)) << 16;
             int G = int(green(c2)) << 8;
             int B = int(blue(c2));
             cBin1 = a | r | g | b; 
             cBin2 = A | R | G | B;           
             int aa = 255 << 24; 
             int rr = r ^ R; 
             int gg = g ^ G; 
             int bb = b ^ B;
             cBin3 = aa | rr | gg | bb;
             matrix3[i][j] = cBin3;           
         }       
       }
       bildEntschluesselt= bildVonMatrixXOR(matrix3);
       bildEntschluesselt.save("data/bildEntschluesselt.bmp");
       image(bildEntschluesselt,0,0);
       println("Entschlüsselung beendet!");   
       entschluesseln = false;
   }
   
}
//////////////////////////////////////////////////////////////////
void zeichnen(){
  bildErgebnis = bildVonMatrix(MatrixGesamt);
  background(255);
  image(bildErgebnis,0,0,cols,rows);   
  save("data/schluesselXOR.bmp");
  permSchluessel = stringVonMatrix(MatrixPermGesamt);
  saveStrings("data/permSchluessel.txt", permSchluessel);
  println("a = "+a+";  b = "+b+";  c = "+c+";  d = "+d+";  delta = "+delta+"; ");
  println("A = "+A+";  B = "+B+";  C = "+C+";  D = "+D+";  Delta = "+Delta+"; ");
  
}
//////////////////////////////////////////////////////////////////
PImage bildVonMatrix(float[][] matrix){  
   float[][] MatrixHisto = matrix;
   PImage bild = createImage(rows,cols,RGB); 
    colorMode(RGB);
    for(int i = 0; i < cols ; i++){
         for(int j = 0; j < rows; j++){ 
              if(MatrixHisto[i][j]==0) {bild.pixels[i + j*cols] = color(0);}
              else { bild.pixels[i + j*cols] = color((MatrixHisto[i][j])%256);}//print(MatrixHisto[i][j]+"  "); }            
           }           
    }                
 return bild;
}
//////////////////////////////////////////////////////////////////////////////
PImage bildVonMatrixXOR(int[][] matrix){  
  // int[][] bearbeitetMatrix = matrix;
   PImage bild = createImage(cols,cols,RGB);    
   for(int i = 0; i < rows; i++){
     for(int j = 0; j < cols; j++){   
        bild.pixels[i + j*cols] = matrix[i][j];
     } 
  }
 return bild;
}
//////////////////////////////////////////////////////////////////////////////
int[][] matrixVonBildXOR(PImage bildEingabe){  
  PImage bild = bildEingabe; 
  int [][] matrix = new int[cols][rows]; 
  for(int i = 0; i < cols ;i++){
     for(int j = 0; j < rows; j++){
       matrix[i][j] = bild.pixels[i + j*cols];
    } 
 }
 return matrix;
}
//////////////////////////////////////////////////////////////////
String[] stringVonMatrix(int[][] matrix){  
   int[][] MatrixPermHisto = matrix;
   String[]schluessel = new String[n];
    for(int i = 0; i < Cols ; i++){
         for(int j = 0; j < rows; j++){ 
           
            String x = str(round(MatrixPermHisto[i][j])% cols);
            //int X = Integer.parseInt(x);
            schluessel[i + j*Cols] = x;
           }           
    }            
 return schluessel;
}
////////////////////////////////////////////////////////////////////////////////
void keyPressed(){  
  if(key == 's'){
    println("XOR und Perm Schlüssel werden erzeugt!");
    schluesselErzeugen = true;    
  }
  if(key == 'v'){  
      println("Bild wird mit XOR verschlüsselt!");
      verschluesseln = true;
    
  }
  if(key == 'e'){  
     println("Bild wird mit XOR entschlüsselt!");
     entschluesseln = true;
  }
  
}
